//+------------------------------------------------------------------+
//|                             #MTF Stochastic Thread WALL MTF.mq4  |
//|                                                                  |
//|     Based on Spudfyre's Thread theory                            |
//|                                                                  |
//|                                                            emda  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Emda"
#property link "http://www.forexfactory.com/showthread.php?t=37111"

#property indicator_minimum -30
#property indicator_maximum 100

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 RoyalBlue
#property indicator_width1 1
#property indicator_color2 Tomato
#property indicator_width2 1
#property indicator_color3 Gold
#property indicator_width3 2
#property indicator_color4 Black
#property indicator_width4 3


#property indicator_level1 23.6
#property indicator_level2 76.4
#property indicator_level3 50
#property indicator_level4 0
#property indicator_levelcolor Gray

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
**************************************************************************/
extern string coment1 = "--- TIMEFRAME ------";
extern int TimeFrame=0;
extern string coment0 = "--- stoch wall params ------";
extern int Periodwall = 14;
extern int Slowing = 3;
extern int MinTF = 5;
extern int MaxTF = 24;
extern int MinElasticity = 20;
extern double ElasticityScaleL = 1.5;
extern double ElasticityScaleH = 1.5;
extern double DeploymentScale = 2.0;
extern string coment2 = "--- display params ------";
extern bool SeeWall = true;
extern bool SeeAverageWall = false;
extern bool AlertCross = false;
extern int Numbars = 0;
extern bool background = true;

//---- buffers

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- indicators
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(1, ExtMapBuffer2);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(2, ExtMapBuffer3);   
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, ExtMapBuffer4);

  
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("MTF_STOCHSWALL ("+TimeFrameStr+")");   
   SetIndexLabel(3,"WALL ("+TimeFrameStr+")");
  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF Parabolic Sar                                         |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();

// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
 
   ExtMapBuffer1[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread WALL","",Periodwall,Slowing,MinTF,MaxTF,MinElasticity,ElasticityScaleL,ElasticityScaleH,DeploymentScale,"",SeeWall,SeeAverageWall,AlertCross,Numbars,background,0,y);
   ExtMapBuffer2[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread WALL","",Periodwall,Slowing,MinTF,MaxTF,MinElasticity,ElasticityScaleL,ElasticityScaleH,DeploymentScale,"",SeeWall,SeeAverageWall,AlertCross,Numbars,background,1,y);
   ExtMapBuffer3[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread WALL","",Periodwall,Slowing,MinTF,MaxTF,MinElasticity,ElasticityScaleL,ElasticityScaleH,DeploymentScale,"",SeeWall,SeeAverageWall,AlertCross,Numbars,background,2,y);
   ExtMapBuffer4[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread WALL","",Periodwall,Slowing,MinTF,MaxTF,MinElasticity,ElasticityScaleL,ElasticityScaleH,DeploymentScale,"",SeeWall,SeeAverageWall,AlertCross,Numbars,background,3,y);
   
      
   }  
   return(0);
  }
//+------------------------------------------------------------------+