//+------------------------------------------------------------------+
//|        MTF_Stochastic_AboveBelowThreshold_mj_v1.00.ex4_vx.xx.mq4 |
//|                      Copyright  2011,                       mj  |
//|                                       http://www.noweb.net/      |
//+------------------------------------------------------------------+
#property copyright "Copyright  mj"
#property link      "http://www.noweb.net/"

#define INDICATOR_NAME		"MTF_Stochastic_AboveBelowThreshold_mj"
#define INDICATOR_VERSION	"_v1.00"

#property  indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 2
#property  indicator_buffers 5
#property  indicator_color1  Red
#property  indicator_color2  Blue
#property  indicator_color3  C'255,120,120'
#property  indicator_color4  C'120,120,255'
#property  indicator_color5 Black
#property indicator_width1 5
#property indicator_width2 5
#property indicator_width3 5
#property indicator_width4 5
#property indicator_width5 5


//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
MODE_SMA    0 Simple moving average, 
MODE_EMA    1 Exponential moving average, 
MODE_SMMA   2 Smoothed moving average, 
MODE_LWMA   3 Linear weighted moving average. 
You must use the numeric value of the MA Method that you want to use
when you set the 'ma_method' value with the indicator inputs.

**************************************************************************/
extern int TimeFrame=0;


//---- indicator parameters
extern string _x = "== WindowNumber this is needed to";
extern string _xx = "display the label on the right Window";
extern int WindowNumber= 1;

extern string _xxx = "== LABEL DISPLAY ==";
extern string AllFontName = "Arial";
extern string DisplayString1 = "SetPeriod > Stoch Treshold";
extern int DisplayString1_FontSize=8;
extern color DisplayString1_FontColor=Silver;
extern int DisplayString1_CORNER=0;  //0-3
extern int DisplayString1_XDISTANCE=0;  
extern int DisplayString1_YDISTANCE=0;  

extern string DisplayString2 = "SetPeriod > Stoch Treshold";
extern int DisplayString2_FontSize=8;
extern color DisplayString2_FontColor=Silver;
extern int DisplayString2_CORNER=1;  //0-3
extern int DisplayString2_XDISTANCE=120;  
extern int DisplayString2_YDISTANCE=0;  

extern string _y = "== Adjust BarHight Between 0 - 2 ==";
extern double AdjustBarHight=1.5;


//---- input parameters
extern string  INFO="--- DPeriod is fix 1 ---";
//---- STOCH 1
extern string  INFO0="--- Stoch 1 ---";
extern int KPeriod1=100;
extern int Slowing1=3;
extern int MaMethod1 = 0; // SMA 0, EMA 1, SMMA 2, LWMA 3
extern int PriceField1 = 0; // Low/High 0, Close/Close 1

extern	double		LONG_ElasitcThreshold_Level1=68;
extern	double     SHORT_ElasitcThreshold_Level1=32;


//---- STOCH 2
extern string  INFO2="--- Stoch 2 ---";
extern int KPeriod2=50;
extern int Slowing2=8;
extern int MaMethod2 = 0; // SMA 0, EMA 1, SMMA 2, LWMA 3
extern int PriceField2 = 0; // Low/High 0, Close/Close 1

extern	double		LONG_ElasitcThreshold_Level2=68;
extern	double     SHORT_ElasitcThreshold_Level2=32;


extern   string  _5="== LimitBarsCount ==";
extern   string  _5a="Limits at start how many bars";
extern   string  _5b="back we display our triggers";
extern   int     LimitBarsCount=400; // LimitBarsCount

//------------------

//------------------
int DPeriod=1;

//---- indicator buffers
double UpBoth_Buffer[];
double DownBoth_Buffer[];
double UpNoStoch2_Buffer[];
double DownNoStoch2_Buffer[];
double None_Buffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
//----  additional buffers are used for counting.
   IndicatorBuffers(5);
    
//---- drawing settings


   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID,5,indicator_color1);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID,5,indicator_color2);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,5,indicator_color3);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID,5,indicator_color4);
   SetIndexStyle(4,DRAW_HISTOGRAM,STYLE_SOLID,5,indicator_color5);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));

//---- 3 indicator buffers mapping
   SetIndexBuffer(0,UpBoth_Buffer);
   SetIndexBuffer(1,DownBoth_Buffer);
   SetIndexBuffer(2,UpNoStoch2_Buffer);
   SetIndexBuffer(3,DownNoStoch2_Buffer);
   SetIndexBuffer(4,None_Buffer);  

//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("");
   SetIndexLabel(0,NULL);
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
   SetIndexLabel(3,NULL);
   SetIndexLabel(4,NULL);
   
//----
//---- initialization done
   DeleteLabelObj();
   
   return(0);
}

//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   ObjectDelete("SoundWhenPriceGoesAbove");
   ObjectDelete("SoundWhenPriceGoesBelow");
   DeleteLabelObj();
   return(0);
}

//+------------------------------------------------------------------+

int DeleteLabelObj()
{

	ObjectDelete("DisplayString1_" + WindowNumber);
	ObjectDelete("DisplayString2_" + WindowNumber);

return(0);
}



//+------------------------------------------------------------------+
//|                                                |
//+------------------------------------------------------------------+
bool alertflag = 0;
int start()
{

   DeleteLabelObj();

// new DisplayString1
  if(!ObjectCreate("DisplayString1_" + WindowNumber, OBJ_LABEL, WindowNumber, 0, 0))
    {
     Print("error: can't create label_object! code #",GetLastError());
     return(0);
    }

   ObjectSetText("DisplayString1_" + WindowNumber, DisplayString1, DisplayString1_FontSize, AllFontName, DisplayString1_FontColor);

   ObjectSet("DisplayString1_" + WindowNumber, OBJPROP_CORNER, DisplayString1_CORNER);
   ObjectSet("DisplayString1_" + WindowNumber, OBJPROP_XDISTANCE, DisplayString1_XDISTANCE);
   ObjectSet("DisplayString1_" + WindowNumber, OBJPROP_YDISTANCE, DisplayString1_YDISTANCE);


// new DisplayString2
  if(!ObjectCreate("DisplayString2_" + WindowNumber, OBJ_LABEL, WindowNumber, 0, 0))
    {
     Print("error: can't create label_object! code #",GetLastError());
     return(0);
    }

   ObjectSetText("DisplayString2_" + WindowNumber, DisplayString2, DisplayString2_FontSize, AllFontName, DisplayString2_FontColor);

   ObjectSet("DisplayString2_" + WindowNumber, OBJPROP_CORNER, DisplayString2_CORNER);
   ObjectSet("DisplayString2_" + WindowNumber, OBJPROP_XDISTANCE, DisplayString2_XDISTANCE);
   ObjectSet("DisplayString2_" + WindowNumber, OBJPROP_YDISTANCE, DisplayString2_YDISTANCE);
  
     double Stoch1, Stoch2;
   datetime TimeArray[];
   int   shift,y=0;
    
    
    
 // Check TimeFrame setting not smaller than current 
 if(TimeFrame < Period() && TimeFrame != 0)
{
      if(alertflag == 0) {Alert("MTF_Stochastic_AboveBelowThreshold: \"TimeFrame\" is less than TimeFrame of current graph."); alertflag = 1;}
   return(0);
}

    
// Plot defined timeframe on to current timeframe   
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   

   
   int nLimit, i;
   int nCountedBars;

           
   nCountedBars = IndicatorCounted();
//---- check for possible errors
   if(nCountedBars<0) 
      return(-1);
//---- last counted bar will be recounted
   if(nCountedBars>0) 
      nCountedBars--;


	 if (LimitBarsCount >= Bars) //
		     {
		     nLimit = Bars-nCountedBars;
	     }	
	  else
	      {
		     nLimit = LimitBarsCount;   
		  }
   		     
   		     
   		        
   for(i=0,y=0;i<nLimit;i++)
   {
   if (Time[i]<TimeArray[y]) y++; 
   
 /***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator timeframe
   Rule 3:  Use 'y' for the indicator's shift value
 **********************************************************/  
     
     
      // we set all and later remove the one we do not use
      UpBoth_Buffer[i] = EMPTY_VALUE;      
      DownBoth_Buffer[i] = EMPTY_VALUE;
      UpNoStoch2_Buffer[i] = EMPTY_VALUE;
      DownNoStoch2_Buffer[i] = EMPTY_VALUE;
      None_Buffer[i] = EMPTY_VALUE;
           
      Stoch1 =iStochastic(NULL, TimeFrame, KPeriod1, DPeriod, Slowing1,MaMethod1, PriceField1, MODE_MAIN, y);
      Stoch2 =iStochastic(NULL, TimeFrame, KPeriod2, DPeriod, Slowing2,MaMethod2, PriceField2, MODE_MAIN, y);
           

   
      // Do UP 
      if (Stoch1 >= LONG_ElasitcThreshold_Level1)
         {   
         
            // Check if we have the second too
         if (Stoch2 >= LONG_ElasitcThreshold_Level2)
            {   
               UpBoth_Buffer[i] = AdjustBarHight;
            }
         else
            {
            UpNoStoch2_Buffer[i] = AdjustBarHight;
            }
      }
         
      // Do DOWN         
      else if (Stoch1  <= SHORT_ElasitcThreshold_Level1)
         {
         // Check if we have the second too
         if (Stoch2 <= SHORT_ElasitcThreshold_Level2)
            {   
               DownBoth_Buffer[i] = AdjustBarHight;
            }
         else
            {
            DownNoStoch2_Buffer[i] = AdjustBarHight;
            }
      }
      else
         {
         
         None_Buffer[i] = AdjustBarHight;
         
         }
   }
      
//---- done
   return(0);
  }
//+------------------------------------------------------------------+
