//+------------------------------------------------------------------+
//|                                   StochasticElastic_mj_vx.xx.mq4 |
//|                      Copyright  2010,                       mj  |
//|                                       http://www.noweb.net/      |
//+------------------------------------------------------------------+
#property copyright "Copyright  mj"
#property link      "http://www.noweb.net/"

#define INDICATOR_NAME		"StochasticElastic_mj"
#define INDICATOR_VERSION	"_v1.00"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_buffers 1
#property indicator_color1 Yellow // Main
#property indicator_width1 2
#property  indicator_style1  STYLE_SOLID



//---- input parameters
extern string  INFO="--- DPeriod is fix 1 ---";
//---- STOCH 1
extern string  INFO0="--- Stoch 1 ---";
extern int KPeriod1=17;
extern int Slowing1=3;
extern int MaMethod1 = 0; // SMA 0, EMA 1, SMMA 2, LWMA 3
extern int PriceField1 = 1; // Low/High 0, Close/Close 1
//---- STOCH 2
extern string  INFO2="--- Stoch 2 ---";
extern int KPeriod2=28;
extern int Slowing2=3;
extern int MaMethod2 = 0; // SMA 0, EMA 1, SMMA 2, LWMA 3
extern int PriceField2 = 1; // Low/High 0, Close/Close 1


//---- DisplayLastBar
extern string  INFO3="Current Bar Display";
extern bool    DisplayLastBar=true;

//------------------
int DPeriod=1;

//---- buffers
double MainBuffer[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;

//---- indicator lines
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0, MainBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name=INDICATOR_NAME + INDICATOR_VERSION + "(Stoch1: ("+KPeriod1+","+DPeriod+","+Slowing1+") (Stoch2: ("+KPeriod2+","+DPeriod+","+Slowing2+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   
//----

   return(0);
  }
//+------------------------------------------------------------------+
//| Stochastic oscillator                                            |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
  {
   double Stoch1, Stoch2;
   int limit, i, dlb;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;

   limit=Bars-counted_bars;
   
   //
   //
   //
   //
   //
   
   // Check NoLastBar;
   if (DisplayLastBar) dlb=0;
   else dlb=1;
   
   for(i=dlb; i<limit; i++)
   {
      Stoch1 =iStochastic(NULL, 0, KPeriod1, DPeriod, Slowing1,MaMethod1, PriceField1, MODE_MAIN, i);
      Stoch2 =iStochastic(NULL, 0, KPeriod2, DPeriod, Slowing2,MaMethod2, PriceField2, MODE_MAIN, i);
           
      if (Stoch1 == Stoch2)
         {   
            MainBuffer[i] = 0;
         }
         
      else if (Stoch1 > Stoch2)
         {   
            MainBuffer[i] = Stoch1 - Stoch2 ;
         }      

      if (Stoch1 < Stoch2)
         {   
            MainBuffer[i] = Stoch2 - Stoch1;
         }
         
   }
      
//---- done
   return(0);
  }
//+------------------------------------------------------------------+