//+------------------------------------------------------------------+
//|                               Spud ver 2.0.mq4                   |
//| Use period M5  not M1 period (M1 is incomplete)                  |
//|                               Copyright  2007, Mulyadi Santoso. |
//|                                                musanto@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Mulyadi Santoso."
#property link      "musanto@yahoo.com"

#property indicator_separate_window
#property indicator_buffers   2
#property indicator_color1    Yellow
#property indicator_color2    Red

#property indicator_maximum   100
#property indicator_minimum   0
#property indicator_level1    23.6
#property indicator_level2    50.0
#property indicator_level3    76.4


// Constant -------------------------------------------------------


// General Var --------------------------------------------------------

//---- input parameters
extern   int       Per      = 60;
extern   int       Pk       = 5;
extern   int       Pd       = 25;
extern   int       Ps       = 3;
extern   int       MaxBar   = 1000;
//---- buffers
double SBuffer[],MaBuffer[];
bool     awal ;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName("Spud Stoch("+DoubleToStr(Per,0)+")");
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,SBuffer);
   SetIndexLabel(0,"Stoch ("+DoubleToStr(Per,0)+")");
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,MaBuffer);
   SetIndexLabel(1,"Ma");
   awal = true;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if (Per<5 || 
       MathMod(Per,5)>0 ||
       Bars<500 ||
       Period()>Per) 
       return;
   
   int       counted_bars=IndicatorCounted(),i,j,k,l,m,
             limit;               // Number bars want to be calculated
   double    sumlo,sumhi,
             loes0,hies0,
             clos1,
             factor                    // different beetwen Asking periode & M5
             ;
   datetime  h0,h1;          
   limit = Bars-counted_bars;          
   if (awal)
   {
      limit = MaxBar;
      awal = false;
   }              
   factor = Per/5;
   for (i=limit-1;i>=0;i--)                          // All bar loop
   {  //Print(" ******************** i : ",i);
      sumlo = 0.0;sumhi=0.0;
      h0 = iTime(NULL,0,i)-(Per * (Ps-1)*60);
      for (j=Ps-1;j>=0;j--)                          // "slowing" loop
      {  
         m    = iBarShift(NULL,0,h0,false);
         clos1=  iClose(NULL,0,m); 
         //Print("time to seek h0 ",TimeToStr(h0,TIME_MINUTES),
         //      " ",TimeToStr(iTime(NULL,0,m),TIME_MINUTES),
         //      " Close 1 : ",clos1
         //      );
         // Collecting Highest + Lowest in pK , M5 chart               
         h1   =  iTime(NULL,0,m)+(Period()-5)*60;
         k    =  iBarShift(NULL,PERIOD_M5,h1,false);
         //Print("in M5 h1 ",TimeToStr(h1,TIME_MINUTES),
         //      " Close  : ",iClose(NULL,PERIOD_M5,k)
         //      );
         
         hies0=  iHigh(NULL,PERIOD_M5,iHighest(NULL,PERIOD_M5,MODE_HIGH,Pk*factor,k));
         loes0=  iLow (NULL,PERIOD_M5,iLowest (NULL,PERIOD_M5,MODE_LOW ,Pk*factor,k));
         //Print(" Pk*factor ",Pk*factor,
         //      " -> Pk Hi : ",hies0," lo : ",loes0);
         
         sumlo+= clos1-loes0;
         sumhi+= hies0-loes0;         
            h0+= Per * 60 ;

      }
      if (sumhi<=0)  SBuffer[i]= 100.0;
      else
      {
         SBuffer[i] = sumlo/sumhi*100;
      }
      MaBuffer[i] = Lreg(i,i+Pd-1);// iMAOnArray(SBuffer,0,Pd,i,MODE_SMA,0);
      if (MaBuffer[i]>100)  MaBuffer[i]=100;
   }
}
double Lreg(int st0, int st1)
{ double    Sx=0,Sxx=0,Sxy=0,Sy;
  double    Beta,Alfa,x,y,c,value,rv;
  int       i,n;

  rv = 0.0;
  n = st1 - st0 + 1 ;                       //int n=m_pos[1]-m_pos[0]+1;
  Sy  =SBuffer[st0];
  Sx  = 0.0;                                // double sumx=0.0;
  Sxy = 0.0;                                // double sumxy=0.0;
  Sxx = 0.0;                                // double sumx2=0.0;
  for (i=1;i<n;i++)                         //for(i=1; i<n; i++)
  {  
     x   = i;   
     y   = SBuffer[st0+i];
     Sx  = Sx + x;                          //sumx+  = i;
     Sy  = Sy + y;                          //sumy+  = value
     Sxx = Sxx + (x* x);                    //sumx2+ = i*i
     Sxy = Sxy + (x* y);                    //sumxy+ = value*i;
  }
  c    = Sxx*n - Sx * Sx;                   //c=sumx2*n-sumx*sumx;
  if (c==0.0) return;                     //if(c==0.0) return;
  Beta = (n*Sxy-Sx*Sy)/c;                   //b=(sumxy*n-sumx*sumy)/c;
  Alfa = (Sy-Beta*Sx)/n;                    //a=(sumy-sumx*b)/n;
  rv = Alfa;       
   return(rv);
}

