//+------------------------------------------------------------------+
//|                             #MTF Stochastic Thread WALL MTF.mq4  |
//|                                                                  |
//|     Based on Spudfyre's Thread theory                            |
//|                                                                  |
//|                                                            emda  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Emda"
#property link "http://www.forexfactory.com/showthread.php?t=37111"

#property indicator_minimum -30
#property indicator_maximum 100

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 IndianRed
#property indicator_color2 IndianRed
#property indicator_color3 IndianRed
#property indicator_color4 IndianRed
#property indicator_color5 IndianRed
#property indicator_color6 IndianRed
#property indicator_color7 IndianRed
#property indicator_color8 Red


#property indicator_level1 23.6
#property indicator_level2 76.4
#property indicator_level3 50
#property indicator_level4 0
#property indicator_levelcolor Gray

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
**************************************************************************/
extern string coment0 = "--- TIMEFRAME ------";
extern int TimeFrame=0;
extern string coment1 = "--- stoch wall params ------";
extern int Periodwall = 14;
extern int Slowing = 3;
extern int MaxTF = 24;
extern int Numbars = 0;

//---- buffers

double Bufferl1[];
double Bufferl2[];
double Bufferl3[];
double Bufferl4[];
double Bufferl5[];
double Bufferl6[];
double Bufferl7[];
double Bufferl8[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

//---- indicators

   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, Bufferl1);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, Bufferl2);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, Bufferl3);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, Bufferl4);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexBuffer(4, Bufferl5);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexBuffer(5, Bufferl6);
   SetIndexStyle(6, DRAW_LINE);
   SetIndexBuffer(6, Bufferl7);
   SetIndexStyle(7, DRAW_LINE);
   SetIndexBuffer(7, Bufferl8);

  
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("("+TimeFrameStr+")");   
   SetIndexLabel(3,"LTFS ("+TimeFrameStr+")");
  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//| MTF Parabolic Sar                                         |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();

// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars;
   limit=Bars-counted_bars;
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
 
   Bufferl1[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread HTFS","",Periodwall,Slowing,MaxTF,0,0,y);
   Bufferl2[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread HTFS","",Periodwall,Slowing,MaxTF,0,1,y);
   Bufferl3[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread HTFS","",Periodwall,Slowing,MaxTF,0,2,y);
   Bufferl4[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread HTFS","",Periodwall,Slowing,MaxTF,0,3,y);
   Bufferl5[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread HTFS","",Periodwall,Slowing,MaxTF,0,4,y);
   Bufferl6[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread HTFS","",Periodwall,Slowing,MaxTF,0,5,y);
   Bufferl7[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread HTFS","",Periodwall,Slowing,MaxTF,0,6,y);
   Bufferl8[i]=iCustom(NULL,TimeFrame,"#MTF Stochastic Thread HTFS","",Periodwall,Slowing,MaxTF,0,7,y);
   
   
      
   }  
   return(0);
  }
//+------------------------------------------------------------------+